## Script (Python) "ploneChar2SystChar"
##title=ploneChar2SystChar
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=input_text

from Products.CMFCore.utils import getToolByName

BROKEN_CHARS_TO_REPLACE = { 'utf-8' : [ ('\xe2\x80\x99', '\''),
                                        ('\xe2\x80\x9a', ','),
                                        ('\xe2\x80\x9e', '\"'),
                                        ('\xe2\x80\xa6', '...'),
                                        ('\xe2\x80\xb9', '<'),
                                        ('\xc5\x92', 'oe'),
                                        ('\xe2\x80\x98', '\''),
                                        ('\xe2\x80\x9c', '\"'),
                                        ('\xe2\x80\x9d', '\"'),
                                        ('\xe2\x80\xa2', '*'),
                                        ('\xe2\x80\x93', '-'),
                                        ('\xe2\x80\x94', '--'),
                                        ('\xcb\x9c', '~'),
                                        ('\xe2\x84\xa2', '(tm)'),
                                        ('\xe2\x80\xba', '-'),
                                        ('\xe2\x80\x93', '>'),
                                        ('\xc5\x93', 'oe'),
                                        ('\xc5\xb8', 'Y'),
                                      ] 
                           }

pp = getToolByName(context, 'portal_properties')
plone_charset = pp.site_properties.getProperty('default_charset', None)
target_charset = pp.plone2pdf_properties.getProperty('target_charset', None)

if not target_charset:
    import sys
    target_charset = sys.getfilesystemencoding()

if plone_charset in BROKEN_CHARS_TO_REPLACE.keys():
    broken_chars = BROKEN_CHARS_TO_REPLACE.get(plone_charset)
    for toRepla, repl in broken_chars:
        input_text = input_text.replace(toRepla, repl)

errors='replace'
inloc = unicode(input_text, plone_charset, errors).encode(target_charset, errors)
return inloc

