
__doc__="""
Plone2Pdf product (skin and basic configuration / customization)
"""

from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.DirectoryView import registerDirectory

skin_globals=globals()

registerDirectory('skins', skin_globals)

# allow sys encoding
from Products.PythonScripts.Utility import allow_module, allow_class

allow_module('sys')

from Products.PortalTransforms.data import datastream
allow_class(datastream)

# put a warning if sysencoding != latin-1
from zLOG import WARNING, LOG
import sys
sysencoding = sys.getfilesystemencoding()
latinsysencoding = 'ISO-8859-1'
if sysencoding.upper() != latinsysencoding:
    LOG("Plone2Pdf", WARNING, "", "htmldoc does not behave well with all charsets, so Plone2Pdf transforms the documents using a target charset (which is you system encoding by default")
    LOG("Plone2Pdf", WARNING, "", "you system encoding is \
not %s (it is %s), pleasy make sure that htmldoc works for \
your encoding" %(latinsysencoding,sysencoding), )
    LOG("Plone2Pdf", WARNING, "", "you can change the target encoding in Plone2Pdf properties in the portal_properties of your ZMI")
        
