## Script (Python) "html2pdf"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=html2pdf
##

REQUEST=context.REQUEST

from Products.CMFCore.utils import getToolByName

pp = getToolByName(context, 'portal_properties')
target_charset = pp.plone2pdf_properties.getProperty('target_charset', None)
htmldoc_opts = pp.plone2pdf_properties.getProperty('htmldoc_opts', None)
htmldoc_opts_override = pp.plone2pdf_properties.getProperty('htmldoc_opts_override', None)

transformer = getToolByName(context, 'portal_transforms') 

pdf = transformer.convertTo(target_mimetype = 'application/pdf',
                            orig = context,
                            charset = target_charset,
                            mimetype = 'text/html',
                            htmldoc_opts_override = htmldoc_opts_override,
                            htmldoc_opts = htmldoc_opts,
                            )

if pdf.getData() and pdf.getData().startswith('%PDF-'):
    REQUEST.RESPONSE.setHeader('Content-type','application/pdf')
    REQUEST.RESPONSE.setHeader('Content-disposition','inline; filename="%s.pdf"' % (context.title_or_id()))
    return pdf
else:
    request = context.REQUEST
    message = 'Error creating PDF file'
    return state.set(context = context, portal_status_message = message)
